package biz.wolter.feedreader.models
{
    import mx.collections.ArrayCollection;
    import mx.controls.Alert;
    import mx.rpc.IResponder;
    import mx.rpc.events.ResultEvent;
    import mx.utils.ObjectProxy;
    import biz.wolter.feedreader.vo.ThreadVO;

    /**
     *
     * @author wolter
     */
    public class GetFeedResponder implements IResponder
    {

        /**
         * Constructor
         */
        public function GetFeedResponder():void
        {
        }

        public var model:FeedModel;

        /**
         * The command failed
         * @param info
         */
        public function fault(event:Object):void
        {
            Alert.show("Leider konnte der letzte Beitrag nicht geladen werden.", "Fehler");
            model.initialized = false;
        }

        /**
         * The command was successful
         * @param data The data returned from the server
         */
        public function result(event:Object):void
        {
            var thread:ThreadVO;
            var result:ObjectProxy;
            var threadProxy:ObjectProxy;
            var threadList:ArrayCollection;
            result = (event as ResultEvent).result as ObjectProxy;
            threadList = result.source.thread;
            model.threadList = new ArrayCollection();
            for each (threadProxy in threadList)
            {
                model.threadList.addItem(buildThread(threadProxy));
            }
            model.forumsURL = result.source.url;
            model.initialized = true;
        }

        // quick and dirty		
        /**
         *
         * @param dayMonthYear
         * @param hourMinute
         * @return
         */
        private function buildDate(dayMonthYear:String, hourMinute:String):Date
        {
            var date:Date;
            date = new Date(int(dayMonthYear.split("-")[2]), int(dayMonthYear.split("-")[1]) - 1, int(dayMonthYear.split("-")[0]), int(hourMinute.split(":")[0]), int(hourMinute.split(":")[1]));
            return date;
        }

        // quick and dirty
        /**
         *
         * @param threadProxy
         * @return
         */
        private function buildThread(threadProxy:ObjectProxy):ThreadVO
        {
            var thread:ThreadVO;
            thread = new ThreadVO();
            thread.id = threadProxy.id;
            thread.title = threadProxy.title;
            thread.author = threadProxy.author;
            thread.date = buildDate(threadProxy.date, threadProxy.time);
            return thread;
        }
    }

}

