package biz.wolter.feedreader.models
{
    import biz.wolter.feedreader.business.FeedReaderDelegate;
    import biz.wolter.feedreader.commands.ShowForumCommand;
    import biz.wolter.feedreader.commands.ShowThreadCommand;
    
    import flash.events.EventDispatcher;
    
    import mx.collections.ArrayCollection;

    /**
     *
     * @author wolter
     */
    public class FeedModel implements IFeedModel
    {
        /**
         * Constructor
         */
        public function FeedModel()
        {
        }

        private var _forumsURL:String;

        private var _initialized:Boolean;

        private var _threadList:ArrayCollection;

        [Bindable]
        public function get forumsURL():String
        {
            return _forumsURL;
        }

        public function set forumsURL(v:String):void
        {
            _forumsURL = v;
        }


        public function getFeed():void
        {
            var delegate:FeedReaderDelegate;
            var responder:GetFeedResponder;

            responder = new GetFeedResponder();
            responder.model = this;
            delegate = new FeedReaderDelegate(responder);
            delegate.getFeed(Forums.JOBFORUMS_ID);

        }

        [Bindable(event="initializedChanged")]
        public function get initialized():Boolean
        {
            return _initialized;
        }

        public function set initialized(v:Boolean):void
        {
            if (_initialized != v)
            {
                _initialized = v;
                dispatchEvent(new Event("initializedChanged"));
            }

        }

        /**
         *
         * @param id
         */
        public function showForum(id:String = Forums.JOBFORUMS_ID):void
        {
            var command:ShowForumCommand;
            command = new ShowForumCommand();
            command.forumsID = id;
            command.forumsURL = forumsURL;
            command.execute();
        }

        /**
         *
         * @param id
         */
        public function showThread(id:String):void
        {
            var command:ShowThreadCommand;
            command = new ShowThreadCommand();
            command.threadID = id;
            command.forumsURL = forumsURL;
            command.execute();
        }

        [Bindable]
        public function get threadList():ArrayCollection
        {
            return _threadList;
        }

        public function set threadList(v:ArrayCollection):void
        {
            _threadList = v;
        }
    }
}