package biz.wolter.feedreader.models
{
    import biz.wolter.feedreader.commands.ShowForumCommand;
    import biz.wolter.feedreader.commands.ShowThreadCommand;
    import biz.wolter.feedreader.vo.ThreadVO;
    
    import mx.collections.ArrayCollection;

    /**
     *
     * @author wolter
     */
    public class FeedMock implements IFeedModel
    {
        /**
         * Constructor
         */
        public function FeedMock()
        {
        }

        private var _forumsURL:String;

        private var _initialized:Boolean;

        private var _threadList:ArrayCollection;

        [Bindable]
        public function get forumsURL():String
        {
            return _forumsURL;
        }

        public function set forumsURL(v:String):void
        {
            _forumsURL = v;
        }


        public function getFeed():void
        {
			// Set mock data for testing purpose
			var thread:ThreadVO;
			thread = new ThreadVO();
			thread.id = "1";
			thread.date = new Date(); // today
			thread.title = "Heute ist ein schöner Tag.";
			thread.author = "Ich";
			threadList = new ArrayCollection();
			threadList.addItem(thread);
        	forumsURL = "http://www.flashforum.de/forum/";
			initialized = true;
        }

        [Bindable]
        public function get initialized():Boolean
        {
            return _initialized;
        }

        public function set initialized(v:Boolean):void
        {
            _initialized = v;
        }

        /**
         *
         * @param id
         */
        public function showForum(id:String = Forums.JOBFORUMS_ID):void
        {
            var command:ShowForumCommand;
            command = new ShowForumCommand();
            command.forumsID = id;
            command.forumsURL = forumsURL;
            command.execute();
        }

        /**
         *
         * @param id
         */
        public function showThread(id:String):void
        {
            var command:ShowThreadCommand;
            command = new ShowThreadCommand();
            command.threadID = id;
            command.forumsURL = forumsURL;
            command.execute();
        }

        [Bindable]
        public function get threadList():ArrayCollection
        {
            return _threadList;
        }

        public function set threadList(v:ArrayCollection):void
        {
            _threadList = v;
        }
    }
}