package biz.wolter.feedreader.models
{
    import mx.collections.ArrayCollection;
    import biz.wolter.feedreader.business.FeedReaderDelegate;
    import biz.wolter.feedreader.commands.ShowForumCommand;
    import biz.wolter.feedreader.commands.ShowThreadCommand;

    /**
     *
     * @author wolter
     */
    public class FeedModel
    {

        private static const JOBFORUMS_ID:String = "32";

        /**
         * Constructor
         */
        public function FeedModel()
        {
        }

        [Bindable]
        public var forumsURL:String;

        [Bindable]
        public var initialized:Boolean;

        [Bindable]
        public var threadList:ArrayCollection;

        public function getFeed():void
        {
            var delegate:FeedReaderDelegate;
            var responder:GetFeedResponder;

            responder = new GetFeedResponder();
            responder.model = this;
            delegate = new FeedReaderDelegate(responder);
            delegate.getFeed(JOBFORUMS_ID);

        }

        /**
         *
         * @param id
         */
        public function showForum(id:String = JOBFORUMS_ID):void
        {
            var command:ShowForumCommand;
            command = new ShowForumCommand();
            command.forumsID = id;
            command.forumsURL = forumsURL;
            command.execute();
        }

        /**
         *
         * @param id
         */
        public function showThread(id:String):void
        {
            var command:ShowThreadCommand;
            command = new ShowThreadCommand();
            command.threadID = id;
            command.forumsURL = forumsURL;
            command.execute();
        }
    }
}