package biz.wolter.feedreader.models
{
    import biz.wolter.feedreader.business.FeedReaderDelegate;
    import biz.wolter.feedreader.commands.ShowForumCommand;
    import biz.wolter.feedreader.commands.ShowThreadCommand;

    import flash.events.EventDispatcher;

    import mx.collections.ArrayCollection;

    /**
     *
     * @author wolter
     */
    public class FeedModel extends EventDispatcher
    {

        private static const JOBFORUMS_ID:String = "32";

        /**
         * Constructor
         */
        public function FeedModel()
        {
        }

        [Bindable]
        public var forumsURL:String;

        private var _initialized:Boolean;

        [Bindable(event="initializedChanged")]
        public function get initialized():Boolean
        {
            return _initialized;
        }

        public function set initialized(v:Boolean):void
        {
            if (_initialized != v)
            {
                _initialized = v;
                dispatchEvent(new Event("initializedChanged"));
            }

        }


        [Bindable]
        public var threadList:ArrayCollection;

        public function getFeed():void
        {
            var delegate:FeedReaderDelegate;
            var responder:GetFeedResponder;

            responder = new GetFeedResponder();
            responder.model = this;
            delegate = new FeedReaderDelegate(responder);
            delegate.getFeed(JOBFORUMS_ID);

        }

        /**
         *
         * @param id
         */
        public function showForum(id:String = JOBFORUMS_ID):void
        {
            var command:ShowForumCommand;
            command = new ShowForumCommand();
            command.forumsID = id;
            command.forumsURL = forumsURL;
            command.execute();
        }

        /**
         *
         * @param id
         */
        public function showThread(id:String):void
        {
            var command:ShowThreadCommand;
            command = new ShowThreadCommand();
            command.threadID = id;
            command.forumsURL = forumsURL;
            command.execute();
        }
    }
}